<?php
/**
// Copyright (C) 2010 - 2012 Mike Feng Jinglong
//
// This program is a commercial software; you cannot redistribute it
// and/or modify it without the explicit consent from the author.
//
// All title and copyright in and to the Product is owned by Mike Feng
// and is protected by international copyright laws and treaty provisions.
// Mike Feng retains all ownership rights in the Product.
// The copyright notice must be reproduced and included on any copy
// that is expressly permitted under this Agreement.
**/

defined('_JEXEC') or die('Restricted access');

/**
 * This file and method will automatically get called by Joomla
 * during the installation process 
 **/
jimport( 'joomla.filesystem.archive' );

error_reporting(E_COMPILE_ERROR|E_ERROR|E_CORE_ERROR);
function com_install() {
	$db =& JFactory::getDBO();
 
    echo '
		<table width="60%" border="0" class="adminform">
		<tr>
			<td align="left">
				<font class="small">&copy; 2010-2012  by Mike Feng<br />http://www.simbunch.com</font><p/>
			</td>
		</tr>
		<tr>
			<td background="#ECECFF">
				<code>Installation Process<br /><br />';
	
	//extract site.zip
	echo '<span>Unzipping site.zip...</span>';
	$zip = JPATH_SITE."/components/com_simanswers/site.zip";
	$destination = JPATH_SITE."/components/com_simanswers/";
	chmod($destination, 0755);
	if (JArchive::extract($zip, $destination)) echo '<span style="color:green">Done!</span><br />';
	chmod($zip, 0777);
	unlink($zip);

	//extract admin.zip
	echo '<span>Unzipping admin.zip...</span>';
	$zip = JPATH_SITE."/administrator/components/com_simanswers/admin.zip";
	$destination = JPATH_SITE."/administrator/components/com_simanswers/";
	chmod($destination, 0755);
	if (JArchive::extract($zip, $destination)) echo '<span style="color:green">Done!</span><br />';
	chmod($zip, 0777);
	unlink($zip);

	//make imagecache writable
	chmod(JPATH_SITE."/components/com_simanswers/imagecache", 0755);
	//make image.php writable
	chmod(JPATH_SITE."/components/com_simanswers/image.php", 0755);
	
	//rule scan
	require_once(JPATH_SITE."/components/com_simanswers/classes/class.sahelper.php");
	SAHelper::ruleScan();

	//add some columns
	addColumn('#__simanswers_comments', 'cdate', 'int(11) NOT NULL DEFAULT 0');
	addColumn('#__simanswers_thumbs', 'cdate', 'int(11) NOT NULL DEFAULT 0');
	addColumn('#__simanswers_votes', 'cdate', 'int(11) NOT NULL DEFAULT 0');
	addColumn('#__simanswers_users', 'nicktype', 'varchar(15) NOT NULL DEFAULT "default"');
	addColumn('#__simanswers_users', 'nickname', 'varchar(50) NOT NULL DEFAULT ""');
	addColumn('#__simanswers_users', 'avatar', 'varchar(50) NOT NULL DEFAULT ""');
	addColumn('#__simanswers_users', 'profile_link', 'tinyint(4) NOT NULL DEFAULT 1');
	addColumn('#__simanswers_users', 'hide_qna', 'tinyint(4) NOT NULL DEFAULT 0');
	addColumn('#__simanswers_users', 'email_new_answer', 'tinyint(4) NOT NULL DEFAULT 1');
	addColumn('#__simanswers_users', 'email_friend', 'tinyint(4) NOT NULL DEFAULT 1');
	//change field type of question title from varchar(255) to text
	$db->setQuery( "ALTER TABLE `#__simanswers_questions` CHANGE `title` `title` TEXT NOT NULL");
	$db->query();

	mkdir(JPATH_SITE."/images/sa_avatars", 0777) && fopen(JPATH_SITE."/images/sa_avatars/index.html", "a");
	if (!is_writable(JPATH_SITE."/images/sa_avatars"))
		echo "<font color='red'>NOTE: &quot;/images/sa_avatars&quot; was not created/not made writable. Please create the folder and chmod it to 777. The installation process will proceed.</font><br />";

	echo '<br /><span color="green">SIMAnswers Installation Complete...</strong> Remember to install and publish the Headboard module, or you may encounter javascript conflicts.</strong></span><br />';
	if (file_exists(JPATH_SITE.'/components/com_parainvite/OpenInviter/openinviter.php'))
		echo '<div style="font-weight:bold;">OpenInviter detected from your ParaInvite installation. No further installation of OpenInviter plugins required!</div>';
	else
		echo '
			<h1>OPTIONAL</h1>Please <a href="http://openinviter.com/download_package.php?package=general" target="_blank">download the <strong>GENERAL PACKAGE</strong></a> and upload the contents of the <code>OpenInviter</code> folder to <code>components/com_simanswers/OpenInviter</code>.<br />
			This allows users to import their email contacts when emailing a question to friends.';
	echo '
			</code>
		</td>
	</tr>
	</table>';
}

function addColumn($tblname, $colname, $colprops) {
	$db =& JFactory::getDBO();

	$columns = array();
	$db->setQuery( "SHOW COLUMNS FROM ".$tblname );
	$results = $db->loadObjectList();
	foreach($results as $result) {
		$columns[] = $result->Field;
	}
	if (!in_array($colname, $columns)) {
		$db->setQuery( "ALTER TABLE $tblname ADD COLUMN `$colname` $colprops" );
		$db->query();
	}
}
?>
