<?php
/**
// Copyright (C) 2010 - 2012 Mike Feng Jinglong
//
// This program is a commercial software; you cannot redistribute it
// and/or modify it without the explicit consent from the author.
//
// All title and copyright in and to the Product is owned by Mike Feng
// and is protected by international copyright laws and treaty provisions.
// Mike Feng retains all ownership rights in the Product.
// The copyright notice must be reproduced and included on any copy
// that is expressly permitted under this Agreement.
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

class modSIMAnswers_CategoriesHelper {
	function init() {
		$document =& JFactory::getDocument();
		$option = JRequest::getVar('option', '');
		if ($option == 'com_simanswers') {
			$saConfig = SAHelper::getConfig();
			if (!$saConfig->mtupgrade) {
				$parameter_script = 'scripts';
				$headerstuff = $document->getHeadData();
				reset($headerstuff[$parameter_script]);
				foreach ($headerstuff[$parameter_script] as $key=>$value){
					if (substr_count($key, 'mootools') > 0)
						unset($headerstuff[$parameter_script][$key]);
				}
				$document->setHeadData( $headerstuff );
			}
		}
		else {
			if (file_exists(JPATH_SITE.'/components/com_simanswers/globals.simanswers.php'))
				require_once(JPATH_SITE.'/components/com_simanswers/globals.simanswers.php');
			else echo 'Install SIMAnswers component first.';
		}
		$document =& JFactory::getDocument();
		$css = JURI::root().'modules/mod_simanswers_categories/css/simanswers_categories.css';
		$document->addStyleSheet($css, 'text/css');
	}
		
	function getCategories($currentcat) {
		$db =& JFactory::getDBO();
		$cats = SAHelper::getCategories();
		$catarray = (array_key_exists($currentcat->id, $cats)) ? $cats[$currentcat->id] : $cats[$currentcat->parent];
		return $catarray;
	}
}
?>