window.addEvent('domready', function() {
	$$('.sahb-tabs').each(function(el) {
		var activetab = (el.hasClass('sahb-tabs-active'));
		el.addEvent('mouseenter', function(e) {
			e.stop();
			if (!activetab) el.addClass('sahb-tabs-active');
			if (el.getElement('.sahb-sub')) el.getElement('.sahb-sub').setStyle('visibility', 'visible');
		});
		el.addEvent('mouseleave', function(e) {
			e.stop();
			if (!activetab) el.removeClass('sahb-tabs-active');
			if (el.getElement('.sahb-sub')) el.getElement('.sahb-sub').setStyle('visibility', 'hidden');
		});
	});
	if ($('sahb-ask-title')) {
		$('sahb-ask-title').addEvent('focus', function(e) { sahb_resetField(this, 'focus', SA_ASK_TITLE_DEFAULT); });
		$('sahb-ask-title').addEvent('blur', function(e) { sahb_resetField(this, 'blur', SA_ASK_TITLE_DEFAULT); });
	}
	if ($('sahb-qna-link')) {
		$('sahb-qna-link').addEvent('click', function(e) {
			if ($('dashboard-qna-tabs'))
				var qnascroll = new Fx.Scroll(window, { offset: {'x': 0, 'y': -10} }).toElement('dashboard-qna-tabs');
		});
	}
	$('sahb-searchfield').addEvent('focus', function(e) { sahb_resetField(this, 'focus', SA_HEAD_SEARCH_DEFAULT); });
	$('sahb-searchfield').addEvent('blur', function(e) { sahb_resetField(this, 'blur', SA_HEAD_SEARCH_DEFAULT); });
});

function sahb_validatesearch(frm) {
	if (!$("sahb-searchfield").value.trim() || $("sahb-searchfield").value == SA_HEAD_SEARCH_DEFAULT) {
		$("sahb-searchfield").setStyle("border-color", "red");
		return false;
	}
	else
		frm.submit();
}

function sahb_resetField(el, e, defaultvalue) {
	if (e == "focus" && el.value == defaultvalue) {
		el.value = "";
		el.removeClass("blurfield");
	}
	else if (e == "blur" && el.value == "") {
		el.value = defaultvalue;
		el.addClass("blurfield");
	}
}
